/*
 * 쐬: 2005/10/27
 * XV:
 * 
 */
package hicharted;

import javax.swing.*;
import java.awt.*;

import hicharted.event.*;
import hicharted.dataStructure.*;

public class DerivationTreePane extends JPanel {
	static final int GAPX = 40;
	static final int GAPY = 40;
	private static int maxX = 0;
	private static int maxY = 0;
	static int countY = 1;
	static Dimension drawArea;

	public DerivationTreePane() {
		countY = 1;
		maxX = 0;
		maxY = 0;
		drawArea = new Dimension(0, 0);
		calcPosition(TreeNode.getRoot());
		calcDrawArea(TreeNode.getRoot());
		setDrawArea();
		//System.out.println(getDrawArea());
	}

	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g;
		Font f1 = new Font("Dialog", Font.PLAIN, 10);
		g2.setFont(f1);
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setStroke(new BasicStroke(1.5f));
		g2.setColor(Color.white);
		g2.setColor(Color.black);
		DrawDerivationTree.draw(g2, TreeNode.getRoot().getChildren1());
	}

	private static void calcPosition(TreeNode n) {
		if (n.getChildren1() != null) {
			n.getChildren1().setRx(n.getRx() + GAPX);
			n.getChildren1().setRy(n.getRy());
			calcPosition(n.getChildren1());
		}
		if (n.getChildren2() != null) {
			n.getChildren2().setRx(n.getRx() + GAPX);
			countY = countY + 1;
			n.getChildren2().setRy(countY * GAPY);
			calcPosition(n.getChildren2());
		}
	}

	public static void calcDrawArea(TreeNode n) {
		if (n.getRx() > maxX) {
			maxX = n.getRx() + 100;
		}

		if (n.getRy() > maxY) {
			maxY = n.getRy() + 100;
		}
		if ((n.getChildren1() != null)) {
			calcDrawArea(n.getChildren1());
		}
		if ((n.getChildren2() != null)) {
			calcDrawArea(n.getChildren2());
		}
	}

	private static void setDrawArea() {
		drawArea.width = maxX;
		drawArea.height = maxY;
	}

	public static Dimension getDrawArea() {
		return drawArea;
	}
}