package hicharted.dataStructure;
import java.awt.*;
import java.util.*;

/**
 * HichartNodeNX
 * 
 *
 */
public class HichartNode {
	private int nodeID = 0; //ʔԍ
	private int NodeTypeNumber = -1; //m[h̎ޔԍ
	private Point drawPoint = new Point(0, 0); //`W
	private Point nodeSize = new Point(0, 0); //m[hTCY
	private int up = 0; //up
	private int down = 0; //down
	private String nodeLabel = ""; //m[hxi[
	private String string = ""; //Zɓ͂镶i[
	private String dispStr = ""; //Z\pi[
	private HichartNode parent = null; //e
	private HichartNode child1 = null; //q1
	private HichartNode child2 = null; //q2
	private HichartNode olderBrother = null; //Z
	private HichartNode youngerBrother = null; //
	private HichartNode root;

	private static HichartNode hit; //Hichart̖؍\qbgۑp
	private static boolean matchFlag = false;

	/**
	 * 
	 */
	public void hichartListFormat() {
		root = new HichartNode();
		root.setChild1(this);
		this.setParent(root);
		this.getParent().root = this.root;

		Point point = new Point(10, 10); //m[h̏W
		Point defaultSize = new Point(60, 30); //m[h̏TCY
		this.setNodeID(1);
		this.getDrawPoint().setLocation(point);
		this.setNodeSize(defaultSize);
		this.setNodeLabel("Module_packet");

	}

	/**
	 * Hichart؍\ɈœnꂽnodeIDZ邩ǂ
	 * @param hn Hichartf[^\
	 * @param nodeID ID
	 * @return Hichartm[h
	 */
	public HichartNode searchHichartNode(HichartNode hn, int nodeID) {
		hit = null;

		if (hn == null)
			return null;
		if (hn.getNodeID() == nodeID) {
			hit = hn;
			return hit;
		}

		if (hit == null && hn.getChild1() != null)
			searchHichartNode(hn.getChild1(), nodeID);
		if (hit == null && hn.getChild2() != null)
			searchHichartNode(hn.getChild2(), nodeID);
		if (hit == null && hn.getYoungerBrother() != null)
			searchHichartNode(hn.getYoungerBrother(), nodeID);
		return hit;
	}

	/**
	 * Hichart؍\ɈœnꂽnodeIDZ邩ǂ
	 * @param hn Hichartf[^\
	 * @param nodeID ID
	 * @param nodeLabel m[hx
	 * @return Hichartm[h
	 */
	public HichartNode searchHichartNode(HichartNode hn, int nodeID, String nodeLabel) {
		hit = null;

		if (hn.getNodeID() == nodeID && hn.getNodeLabel().compareTo(nodeLabel) == 0) {
			hit = hn;
			return hit;
		}

		if (hit == null && hn.getChild1() != null)
			searchHichartNode(hn.getChild1(), nodeID);
		if (hit == null && hn.getChild2() != null)
			searchHichartNode(hn.getChild2(), nodeID);
		if (hit == null && hn.getYoungerBrother() != null)
			searchHichartNode(hn.getYoungerBrother(), nodeID);
		return hit;
	}

	/**
	 * Hichart؍\ɈœnꂽnodeIDZ邩ǂ
	 * @param nodeID m[hID
	 * @return Hichartm[h
	 */
	public HichartNode searchHichartNode(int nodeID) {
		hit = null;

		if (this.getNodeID() == nodeID) {
			hit = this;
		} else if (this.getParent() != null && this.getParent().getNodeID() == nodeID) {
			hit = this.getParent();
		} else if (this.getChild1() != null && this.getChild1().getNodeID() == nodeID) {
			hit = this.getChild1();
		} else if (this.getChild2() != null && this.getChild2().getNodeID() == nodeID) {
			hit = this.getChild2();
		} else if (this.getYoungerBrother() != null && this.getYoungerBrother().getNodeID() == nodeID) {
			hit = this.getYoungerBrother();
		} else if (this.getOlderBrother() != null && this.getOlderBrother().getNodeID() == nodeID) {
			hit = this.getOlderBrother();
		}

		return hit;
	}

	/**
	 * Hichart؍\̃Ň
	 */
	public int searchHichartNodeLink(HichartNode hn, int nodeID) {
		int hit = -1;

		if (hn == null) {
			return -1;
		}

		if (hn.getParent() != null && hn.getParent().getNodeID() == nodeID) {
			hit = 1;
		} else if (hn.getChild1() != null && hn.getChild1().getNodeID() == nodeID) {
			hit = 2;
		} else if (hn.getOlderBrother() != null && hn.getOlderBrother().getNodeID() == nodeID) {
			hit = 3;
		} else if (hn.getYoungerBrother() != null && hn.getYoungerBrother().getNodeID() == nodeID) {
			hit = 4;
		} else if (hn.getChild2() != null && hn.getChild2().getNodeID() == nodeID) {
			hit = 5;
		}

		return hit;
	}

	/**
	 * Jgm[h̑SĂ̎qT
	 */
	public Vector searchChildren() {
		HichartNode current = this;
		Vector children = new Vector();

		if (current.getChild1() != null) {
			current = current.getChild1();
			children.add(current);
			while (current.getYoungerBrother() != null) {
				current = current.getYoungerBrother();
				children.add(current);
			}
		} else {
			children = null;
		}

		return children;
	}

	/**
	 * m[h̃}b`O
	 * @param graph Hichartf[^\
	 * @param handle nh
	 * @return boolean
	 */
	public static boolean match(HichartNode graph, HichartNode handle) {
		matchFlag = true;

		if (graph == null || handle == null) {
			return false;
		} else {
			if (graph.getChild1() != null && handle.getChild1() != null)
				match(graph.getChild1(), handle.getChild1());
			else if ((graph.getChild1() == null && handle.getChild1() != null) || (graph.getChild1() != null && handle.getChild1() == null)) {
				matchFlag = false;
				return matchFlag;
			}
			if (graph.getChild2() != null && handle.getChild2() != null && matchFlag == true)
				match(graph.getChild2(), handle.getChild2());
			else if ((graph.getChild2() == null && handle.getChild2() != null) || (graph.getChild2() != null && handle.getChild2() == null)) {
				matchFlag = false;
				return matchFlag;
			}

			if (graph.getYoungerBrother() != null && handle.getYoungerBrother() != null && matchFlag == true)
				match(graph.getYoungerBrother(), handle.getYoungerBrother());
			else if ((graph.getYoungerBrother() == null && handle.getYoungerBrother() != null) || (graph.getYoungerBrother() != null && handle.getYoungerBrother() == null)) {
				matchFlag = false;
				return matchFlag;
			}

			if (matchFlag == true && graph.getNodeLabel().compareTo(handle.getNodeLabel()) == 0) {
				matchFlag = true;
				return matchFlag;
			} else {
				matchFlag = false;
				return matchFlag;
			}
		}
	}

	/**
	 * qAZ̃N`FbN
	 * @param hn Jg̃m[h
	 * @return boolean
	 */
	public boolean checkNullLink(HichartNode hn) {
		if (hn == null)
			return false;
		else {
			if (hn.getChild1() == null && hn.getChild2() == null && hn.getYoungerBrother() == null && hn.getOlderBrother() == null)
				return true;
			else
				return false;
		}
	}

	/**
	 * m[h̃Rs[
	 * @return Hichartm[h
	 */
	public HichartNode copyNode() {
		HichartNode dest = new HichartNode();

		dest.setNodeID(this.getNodeID());
		dest.setNodeTypeNumber(this.getNodeTypeNumber());
		dest.setNodeLabel(this.getNodeLabel());

		return dest;
	}

	/**
	 * HichartXg\
	 */
	public static void print_H_Node(HichartNode hn) {
		if (hn == null)
			return;
		System.out.println("--------------------------------------------------------------------");
		System.out.println("nodeId:" + hn.getNodeID());
		System.out.println("nodeLabel:" + hn.getNodeLabel());
		if (hn.getParent() != null)
			System.out.println("parent:" + hn.getParent().getNodeID());
		if (hn.getOlderBrother() != null)
			System.out.println("olderBrother:" + hn.getOlderBrother().getNodeID());
		System.out.println("");

		if (hn.getChild1() != null) {
			System.out.println("qL");
			print_H_Node(hn.getChild1());
		}
		if (hn.getChild2() != null) {
			System.out.println("qL");
			print_H_Node(hn.getChild2());
		}
		if (hn.getYoungerBrother() != null) {
			System.out.println("L");
			print_H_Node(hn.getYoungerBrother());
		}
	}

	public void setParent(HichartNode parent) {
		this.parent = parent;
	}

	public HichartNode getParent() {
		return parent;
	}

	public void setNodeID(int nodeID) {
		this.nodeID = nodeID;
	}

	public int getNodeID() {
		return nodeID;
	}

	public void setNodeTypeNumber(int nodeTypeNumber) {
		NodeTypeNumber = nodeTypeNumber;
	}

	public int getNodeTypeNumber() {
		return NodeTypeNumber;
	}

	public void setDrawPoint(Point drawPoint) {
		this.drawPoint = drawPoint;
	}

	public Point getDrawPoint() {
		return drawPoint;
	}

	public void setNodeSize(Point nodeSize) {
		this.nodeSize = nodeSize;
	}

	public Point getNodeSize() {
		return nodeSize;
	}

	public void setUp(int up) {
		this.up = up;
	}

	public int getUp() {
		return up;
	}

	public void setDown(int down) {
		this.down = down;
	}

	public int getDown() {
		return down;
	}

	public void setNodeLabel(String nodeLabel) {
		this.nodeLabel = nodeLabel;
	}

	public String getNodeLabel() {
		return nodeLabel;
	}

	public void setString(String string) {
		this.string = string;
	}

	public String getString() {
		return string;
	}

	public void setChild1(HichartNode child) {
		this.child1 = child;
		this.child1.setParent(this);
		//this.root = child.root;
	}

	public void setChild2(HichartNode child) {
		this.child2 = child;
		this.child2.setParent(this);
		//this.root = child.root;
	}

	public void setChild1(int id, String nodeLabel) {
		this.child1 = new HichartNode();
		this.child1.setNodeID(id);
		this.child1.setNodeLabel(nodeLabel);
		this.child1.setParent(this);
		//this.child1.root = this.root;
	}

	public void setChild2(int id, String nodeLabel) {
		this.child2 = new HichartNode();
		this.child2.setNodeID(id);
		this.child2.setNodeLabel(nodeLabel);
		this.child2.setParent(this);
		//this.child2.root = this.root;
	}

	public HichartNode getChild1() {
		return child1;
	}

	public HichartNode getChild2() {
		return child2;
	}

	public void setOlderBrother(HichartNode olderBrother) {
		this.olderBrother = olderBrother;
	}

	public HichartNode getOlderBrother() {
		return olderBrother;
	}

	public void setYoungerBrother(HichartNode youngerBrother) {
		this.youngerBrother = youngerBrother;
		this.youngerBrother.setOlderBrother(this);
	}

	public void setYoungerBrother(int id, String nodeLabel) {
		this.youngerBrother = new HichartNode();
		this.youngerBrother.setNodeID(id);
		this.youngerBrother.setNodeLabel(nodeLabel);
		this.youngerBrother.setOlderBrother(this);
	}

	public HichartNode getYoungerBrother() {
		return youngerBrother;
	}

	public HichartNode getRoot() {
		return root;
	}

	public void setRoot(HichartNode hn) {
		this.root = hn;
	}

	public void setDispStr(String str) {
		this.dispStr = str;
	}

	public String getDispStr() {
		return this.dispStr;
	}

}