package hicharted.dataStructure;

import java.util.*;

/**
 * p[YɃfx[VV[PX쐬
 * 
 *
 */
public class Sequence {
	private Vector before = new Vector();
	private int productionNumber = -1; //ҌɎgKԍ
	private HichartNode after = null; //Ҍ̃m[hԍ
	private String label = ""; //rootAendm[hʗp
	private Sequence back = null; //sequencȇOQ
	private Sequence next = null; //sequencěQ

	private static Sequence root = new Sequence();
	private static Sequence end = new Sequence();

	private TreeNode parentTreeNode = null;

	/**
	 * 
	 *
	 */
	public static void initialize() {
		setRoot();
	}

	/**
	 * Xgꗗ\
	 */
	public void printSequence() {
		Sequence sq = null;
		sq = Sequence.getRoot();
		int i = 0;
		HichartNode temp = null;

		while (sq.next != null) {
			if (sq.getAfter() != null) {
				System.out.println("--------------------------------------------------------------------");
				System.out.print(" p_number: " + sq.getProductionNumber() + "     after: " + sq.getAfter().getNodeID());
			}
			for (i = 0; i < sq.before.size(); i++) {
				if (sq.before.get(i) != null) {
					temp = (HichartNode) sq.before.get(i);
					System.out.print("     before[" + i + "]: " + temp.getNodeID());
				}
			}
			System.out.println("");
			System.out.println("--------------------------------------------------------------------");
			sq = sq.next;
		}
	}

	/**
	 * N̏I
	 */
	public void sequence_end_p(Sequence s) {
		s.getBack().setNext(end);
		end.setBack(s.getBack());
	}

	private static void setRoot() {
		root = new Sequence();
		end = new Sequence();
		root.next = end;
		end.back = root;
		root.label = "root";
		end.label = "end";
	}

	public static Sequence getRoot() {
		return root;
	}

	/**
	 * f[^̒ǉ
	 * @param before ҌÕm[h
	 * @param productionNumber Ҍ鐶K
	 * @param after Ҍ̃m[h
	 */
	public void add(Vector before, int productionNumber, HichartNode after) {
		Sequence newNode = new Sequence();
		newNode.before = before;
		newNode.productionNumber = productionNumber;
		newNode.after = after;

		getEnd().back.next = newNode;
		newNode.next = getEnd();
		newNode.back = getEnd().back;
		getEnd().back = newNode;

	}

	public static Sequence getEnd() {
		return end;
	}

	public void setProductionNumber(int p_number) {
		this.productionNumber = p_number;
	}

	public int getProductionNumber() {
		return productionNumber;
	}

	public void setAfter(HichartNode after) {
		this.after = after;
	}

	public HichartNode getAfter() {
		return after;
	}

	public void setBack(Sequence back) {
		this.back = back;
	}

	public Sequence getBack() {
		return back;
	}

	public void setNext(Sequence next) {
		this.next = next;
	}

	public Sequence getNext() {
		return next;
	}

	public void setBefore(Vector before) {
		this.before = before;
	}

	public Vector getBefore() {
		return before;
	}

	public String getLabel() {
		return label;
	}

	public void setParentTreeNode(TreeNode current) {
		this.parentTreeNode = current;
	}

	public TreeNode getParentTreeNode() {
		return this.parentTreeNode;
	}
}