package hicharted.hcpgg;

import hicharted.dataStructure.*;
import hicharted.*;

public class P24 extends Production {
	public P24() {
		this.setRuleNo(24);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Fundamental_statement");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("imperative_goto");
		rhs.setNodeID(1);
		this.setRhs(rhs);

		this.setLeftMargin(State.TERMINAL_LEFT);
		this.setRightMargin(State.TERMINAL_RIGHT);
	}

	public void coordinateAttCalcI(TreeNode n) {
		n.setX1(n.getX0());
		n.setTop1(n.getTop0());

	}

	public void coordinateAttCalcS(TreeNode n) {
		n.setY0(n.getY1());
		n.setBottom1(n.getY1() + n.getH1());
		n.setBottom0(n.getBottom1());

		n.getParent().setY1(n.getY0());
		n.getParent().setBottom1(n.getBottom0());
	}

	public void genSvg(TreeNode n) {
		n.getSSvg1().append("<rect stroke=\"black\" fill=\"white\" fill-opacity=\"1\" rx=\"" + n.getH1() / 2 + "\" ry=\"" + n.getH1() / 2 + "\" x=\"" + n.getX1() + "\" y=\"" + n.getY1() + "\" width=\"" + n.getW1() + "\" height=\"" + n.getH1() + "\">\n");
		n.getSSvg1().append("</rect>\n");
		n.setSSvg0(n.getSSvg1());
	}
	public void cyclomaticCalc(TreeNode n) {
		n.setCy0(0);
	}
}