package hicharted.hcpgg;

import hicharted.dataStructure.*;
import hicharted.*;

import hicharted.attribute.*;
import java.util.*;

public class P25 extends Production {
	public P25() {
		this.setRuleNo(25);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Blocked_statement");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("block_identifier");
		rhs.setNodeID(1);

		rhs.setChild1(2, "Abstract_compound");
		this.setRhs(rhs);

		this.setLeftMargin(State.DEFINED_LEFT);
		this.setRightMargin(State.DEFINED_RIGHT);
	}

	public void coordinateAttCalcI(TreeNode n) {
		//p
		n.setX1(n.getX0());
		n.setX2(n.getX1() + n.getW1() + n.getGapX());
		n.setTop1(n.getTop0());
		n.setTop2(n.getTop0());

		//qɒlp
		n.getChildren1().setX0(n.getX2());
		n.getChildren1().setTop0(n.getTop2());
	}

	public void coordinateAttCalcS(TreeNode n) {
		n.setY1(n.getY2());
		n.setY0(n.getY1());
		n.setBottom1(n.getBottom2());
		n.setBottom0(n.getBottom1());

		n.getParent().setY1(n.getY0());
		n.getParent().setBottom1(n.getBottom0());
	}

	public void genSvg(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setSSvg2(n.getChildren1().getSSvg0());
		}

		n.setSSvg1(n.getSSvg2());
		n.getSSvg1().append("\n\n<!-- nodeID:" + n.getTemplink().getNodeID() + " nodeLabel:" + n.getTemplink().getNodeLabel() + " -->\n");
		n.getSSvg1().append("<g>\n");
		n.getSSvg1().append("<rect x=\"" + n.getX1() + "\" y=\"" + n.getY1() + "\" width=\"" + n.getW1() + "\" height=\"" + n.getH1() + "\" fill=\"white\" fill-opacity=\"1\" stroke=\"black\">\n");
		n.getSSvg1().append("</rect>\n");
		n.getSSvg1().append("<line x1=\"" + (n.getX1() + this.getLeftMargin()) + "\" y1=\"" + n.getY1() + "\" x2=\"" + (n.getX1() + this.getLeftMargin()) + "\" y2=\"" + (n.getY1() + n.getH1()) + "\" stroke=\"black\">\n");
		n.getSSvg1().append("</line>\n");
		n.getSSvg1().append("</g>\n");
		if (State.getDispType() == 0) {
			n.getSSvg1().append("<line x1=\"" + (n.getX1() + n.getW1()) + "\" y1=\"" + (n.getY1() + (n.getH1()) / 2) + "\" x2=\"" + n.getX2() + "\" y2=\"" + (n.getY2() + (n.getH1()) / 2) + "\" stroke=\"black\">\n");
			n.getSSvg1().append("</line>\n");
		}

		Vector strings = SVGout.getStrings(n.getTemplink().getDispStr());
		int gapY = 0;
		for (int i = 0; i < strings.size(); i++) {
			n.getSSvg1().append("<text x=\"" + (n.getX1() + State.ADJUST_ID_X) + "\" y=\"" + (n.getY1() + State.ADJUST_ID_Y + gapY) + "\" font-size=\"" + State.FONT_SIZE + "\">" + strings.get(i) + "</text>\n");
			gapY += State.ROWGAP;
		}
		n.setSSvg0(n.getSSvg1());
	}

	public void cyclomaticCalc(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setCy2(n.getChildren1().getCy0());
		}
		n.setCy0(n.getCy2());
	}

}
