package hicharted.hcpgg;

import hicharted.dataStructure.*;
import hicharted.*;

import hicharted.attribute.*;
import java.util.*;

public class P30 extends Production {
	public P30() {
		this.setRuleNo(30);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Block_specification");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("block_specification");
		rhs.setNodeID(1);
		this.setRhs(rhs);

		this.setLeftMargin(State.GENERAL_LEFT);
		this.setRightMargin(State.GENERAL_RIGHT);
	}

	public void coordinateAttCalcI(TreeNode n) {
		n.setX1(n.getX0());
		n.setTop1(n.getTop0());

		//x2,top2,x3,ytop3m[h͂̐Kɂ݂͑Ȃ0ŏ
		n.setX2(n.setTop2(n.setX3((n.setTop3(0)))));
	}

	public void coordinateAttCalcS(TreeNode n) {
		//n.setY1(n.getTop0());
		n.setY0(n.getY1());
		n.setBottom1(n.getY1() + n.getH1());
		n.setBottom0(n.getBottom1());

		n.getParent().setY2(n.getY0());
		n.getParent().setBottom2(n.getBottom0());

		//y2,bottom2,y3,bottom3m[h͂̐Kɂ݂͑Ȃ0ŏ
		n.setY2(n.setBottom2(n.setY3(n.setBottom3(0))));
	}

	public void genSvg(TreeNode n) {
		n.getSSvg1().append("\n\n<!-- nodeID:" + n.getTemplink().getNodeID() + " nodeLabel:" + n.getTemplink().getNodeLabel() + " -->\n");
		n.getSSvg1().append("<g>\n");
		n.getSSvg1().append("<rect x=\"" + n.getX1() + "\" y=\"" + n.getY1() + "\" width=\"" + n.getW1() + "\" height=\"" + n.getH1() + "\" fill=\"white\" fill-opacity=\"1\" stroke=\"black\">\n");
		n.getSSvg1().append("</rect>\n");
		n.getSSvg1().append("</g>\n");

		Vector strings = SVGout.getStrings(n.getTemplink().getDispStr());
		int gapY = 0;
		for (int i = 0; i < strings.size(); i++) {
			n.getSSvg1().append("<text x=\"" + (n.getX1() + State.ADJUST_ID_X) + "\" y=\"" + (n.getY1() + State.ADJUST_ID_Y + gapY) + "\" font-size=\"" + State.FONT_SIZE + "\">" + strings.get(i) + "</text>\n");
			gapY += State.ROWGAP;
		}
		n.setSSvg0(n.getSSvg1());
	}

	public void cyclomaticCalc(TreeNode n) {
		n.setCy0(0);
	}

}