package hicharted.hcpgg;

import hicharted.dataStructure.*;
import hicharted.*;

import hicharted.attribute.*;
import java.util.*;

public class P36 extends Production {
	public P36() {
		this.setRuleNo(36);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("Parallel_statement");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("parallel");
		rhs.setNodeID(1);

		rhs.setChild1(2, "Statement_list");
		this.setRhs(rhs);

		this.setLeftMargin(State.PARAIF_LEFT);
		this.setRightMargin(State.PARAIF_RIGHT);
	}

	public void coordinateAttCalcI(TreeNode n) {
		//p
		n.setX1(n.getX0());
		n.setX2(n.getX1() + n.getW1() + n.getGapX());
		n.setTop1(n.getTop0());
		n.setTop2(n.getTop0());

		//qɒlp
		n.getChildren1().setX0(n.getX2());
		n.getChildren1().setTop0(n.getTop2());
	}

	public void coordinateAttCalcS(TreeNode n) {
		n.setY1(n.getY2());
		n.setY0(n.getY1());
		n.setBottom1(n.getBottom2());
		n.setBottom0(n.getBottom1());

		n.getParent().setY1(n.getY0());
		n.getParent().setBottom1(n.getBottom0());
	}

	public void genSvg(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setSSvg2(n.getChildren1().getSSvg0());
		}

		n.setSSvg1(n.getSSvg2());
		n.getSSvg1().append("\n\n<!-- nodeID:" + n.getTemplink().getNodeID() + " nodeLabel:" + n.getTemplink().getNodeLabel() + " -->\n");
		n.getSSvg1().append("<polygon points=\"" + n.getX1() + "," + n.getY1() + " " + n.getX1() + "," + n.getBottom1() + " " + (n.getX1() + ((5 * n.getW1()) / 6)) + "," + n.getBottom1() + " " + (n.getX1() + n.getW1()) + "," + (n.getY1() + (n.getH1() / 2)) + " " + (n.getX1() + ((5 * n.getW1()) / 6)) + "," + n.getY1() + "\" stroke=\"black\" fill=\"white\" fill-opacity=\"1\">\n");
		n.getSSvg1().append("</polygon>\n");
		n.getSSvg1().append("<polyline points=\"" + (n.getX1() + ((4 * n.getW1()) / 6)) + "," + n.getY1() + " " + (n.getX1() + ((5 * n.getW1()) / 6)) + "," + (n.getY1() + (n.getH1() / 2)) + " " + (n.getX1() + ((4 * n.getW1()) / 6)) + "," + n.getBottom1() + "\" style=\"fill:white; fill-opacity:0\" stroke=\"black\">\n");
		n.getSSvg1().append("</polyline>\n");
		n.getSSvg1().append("<line x1=\"" + (n.getX1() + n.getW1()) + "\" y1=\"" + (n.getY1() + (n.getH1() / 2)) + "\" x2=\"" + n.getX2() + "\" y2=\"" + (n.getY2() + (n.getH1() / 2)) + "\" stroke=\"black\">\n");
		n.getSSvg1().append("</line>\n");

		Vector strings = SVGout.getStrings(n.getTemplink().getDispStr());
		int gapY = 0;
		for (int i = 0; i < strings.size(); i++) {
			n.getSSvg1().append("<text x=\"" + (n.getX1() + State.ADJUST_ID_X) + "\" y=\"" + (n.getY1() + State.ADJUST_ID_Y + gapY) + "\" font-size=\"" + State.FONT_SIZE + "\">" + strings.get(i) + "</text>\n");
			gapY += State.ROWGAP;
		}
		n.setSSvg0(n.getSSvg1());
	}

	public void cyclomaticCalc(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setCy2(n.getChildren1().getCy0());
		}
		n.setCy0(n.getCy2());
	}
}