package hicharted.hcpgg;

import hicharted.dataStructure.*;
import hicharted.*;

public class P66 extends Production {
	public P66() {
		this.setRuleNo(66);
		HichartNode lhs = new HichartNode();
		HichartNode rhs = new HichartNode();

		//left hand side
		lhs.setNodeLabel("When_statement");
		lhs.setNodeID(0);
		this.setLhs(lhs);

		//right hand side
		rhs.setNodeLabel("Choice_statement");
		rhs.setNodeID(1);

		rhs.setYoungerBrother(2, "When_statement");
		this.setRhs(rhs);
	}

	public void coordinateAttCalcI(TreeNode n) {
		n.setX1(n.getX0());
		n.setX2(n.getX1());
		n.setTop1(n.getTop0());
		n.setTop2(n.getBottom1() + n.getGapY());

		//qm[h֌p
		n.getChildren1().setX0(n.getX1());
		n.getChildren1().setTop0(n.getTop1());
		n.getChildren2().setX0(n.getX2());
		n.getChildren2().setTop0(n.getTop2());

	}

	public void coordinateAttCalcS(TreeNode n) {
		n.setY0(n.getY1());
		n.setBottom0(n.getBottom2());

		if (n.getParent().getChildren1() == n) {
			n.getParent().setY1(n.getY0());
			n.getParent().setBottom1(n.getBottom0());
		} else {
			n.getParent().setY2(n.getY0());
			n.getParent().setBottom2(n.getBottom0());
		}

		//x3,y3,top3,bottom3m[h͂̐Kɂ݂͑Ȃ0ŏ
		n.setX3(n.setY3(n.setTop3(n.setBottom3(0))));
	}

	public void genSvg(TreeNode n) {
		n.setSSvg1(n.getChildren1().getSSvg0());
		n.setSSvg2(n.getChildren2().getSSvg0());
		if (State.getDispType() == 0) {
			n.getSSvg1().append("<line x1=\"" + (n.getX1() + State.EDGE_X_GAP) + "\" y1=\"" + n.getBottom1() + "\" x2=\"" + (n.getX2() + State.EDGE_X_GAP) + "\" y2=\"" + n.getChildren2().getY0() + "\" stroke=\"black\">\n" + "</line>\n");
		}
		n.getSSvg1().append(n.getSSvg2());
		n.setSSvg0(n.getSSvg1());
	}

	public void cyclomaticCalc(TreeNode n) {
		if (n.getChildren1() != null) {
			n.setCy1(n.getChildren1().getCy0());
		}

		if (n.getChildren2() != null) {
			n.setCy2(n.getChildren2().getCy0());
		}
		n.setCy0(n.getCy1() + n.getCy2());
	}
}