package hicharted.parser;

import hicharted.State;
import hicharted.dataStructure.*;
import hicharted.event.Message;
import hicharted.attribute.*;
import hicharted.hcpgg.*;
import hicharted.*;

import java.util.*;
import java.awt.*;

/**
 * p[YsNX
 */
public class Parser {
	int p_precedence = 0; //HichartXg̃Jgm[hƐem[h̏ʊ֌W
	int c_precedence = 0; //HichartXg̃Jgm[hƎq̏ʊ֌W
	int o_precedence = 0; //HichartXg̃Jgm[hƌZ̏ʊ֌W
	int y_precedence = 0; //HichartXg̃Jgm[hƒ̏ʊ֌W

	Message message = new Message(); //bZ[W_CAO{bNX
	Productions prs = new Productions();
	Top top = new Top();
	
	/**
	 * 
	 *
	 */
	public void init() {
		TreeNode.setRoot();
	}

	/**
	 * \͗pHichart̃Xg1
	 * @param hn Rs[HichartList
	 * @param operation Rs[HichartList
	 */
	public void generate_operation_hichart_list(HichartNode hn, HichartNode operation) {
		operation.setRoot(operation);
		copyHichartList(hn, operation);
	}
	/**
	 * \͗pHichart̃Xg2
	 * @param hn Rs[HichartList
	 * @param operation Rs[HichartList
	 */
	private void copyHichartList(HichartNode hn, HichartNode operation) {
		int temp;

		operation.setNodeLabel(new String(hn.getNodeLabel())); //pXgɓ͂ꂽHichartxRs[
		operation.setNodeID(hn.getNodeID()); //pXg̃ZIDԍt

		if (operation.getParent() != null && operation.getParent().getRoot() != null)
			operation.setRoot(operation.getParent().getRoot());

		if (hn.getChild1() != null) { //q1
			operation.setChild1(new HichartNode());
			operation.getChild1().setRoot(operation.getRoot());
			copyHichartList(hn.getChild1(), operation.getChild1());
		}

		if (hn.getChild2() != null) { //q2
			operation.setChild2(new HichartNode());
			operation.getChild2().setRoot(operation.getRoot());
			copyHichartList(hn.getChild2(), operation.getChild2());
		}

		if (hn.getYoungerBrother() != null) { //킪
			operation.setYoungerBrother(new HichartNode());
			operation.getYoungerBrother().setRoot(operation.getRoot());
			copyHichartList(hn.getYoungerBrother(), operation.getYoungerBrother());
		}
	}
	/**
	 * \؂̍WlHichartXgƁA͐`Xgɑ
	 * @param pt \؍\
	 */
	public static void parsetree_to_hichart(TreeNode pt) {
		if (pt.getTemplink() != null) { //`Xg̒lݒ
			pt.getTemplink().getDrawPoint().x = pt.getX1();
			pt.getTemplink().getDrawPoint().y = pt.getY1();
			pt.getTemplink().setNodeSize(new Point(pt.getW1(), pt.getH1()));
		}

		if (pt.getHlink() != null) { //HichartXg̒lݒ
			pt.getHlink().getDrawPoint().x = pt.getX1();
			pt.getHlink().getDrawPoint().y = pt.getY1();
			pt.getHlink().setNodeSize(new Point(pt.getW1(), pt.getH1()));
		}

		if (pt.getChildren1() != null)
			parsetree_to_hichart(pt.getChildren1());

		if (pt.getChildren2() != null)
			parsetree_to_hichart(pt.getChildren2());
	}

	/**
	 * \̓C
	 * @param operation \͑Ώ
	 * @return boolean 
	 */
	public boolean hcpggAnalysis(HichartNode operation) {
		Vector orderdList = new Vector(); //\͎ɃVtgm[hi[
		orderdList.add(operation.getChild1());
		boolean parseFlag = true;

		State.currentNode = operation.getChild1();

		while (parseFlag == true) {
			parseFlag = this.precedenceAnalysis(State.currentNode, orderdList);
		}
		if (operation.checkNullLink(State.currentNode) == true && State.currentNode.getNodeLabel().compareTo("Module_packet") == 0) {
			State.currentNode = null;
			return true;
		} else {
			State.currentNode = null;
			return false;
		}
	}
	
	/**
	 * qm[hɃVtg\
	 * @param operation \͑ΏHichart\
	 * @param orderList Vtgm[hi[Ă郊Xg
	 * @return int 0: Vtg\, 1: Vtgs(rs\Aqm[hȂ), 9: ̑G[
	 */
	public int checkChild1Shift(HichartNode operation, Vector orderList) {
		if (operation.getChild1() == null || OrderList.search(orderList, operation.getChild1()) == true) {
			return 1;
		} else {
			int precedence = PrecedenceRelation.getPrecedence(PrecedenceRelation.toNumber(operation), PrecedenceRelation.toNumber(operation.getChild1()));
			if (precedence == 0) {
				return 9;
			} else if (precedence == 1 || precedence == 2) {
				return 0;
			} else if (precedence == 4) {
				return 1;
			} else {
				return 9;
			}
		}
	}
	
	/**
	 * m[hɃVtg\
	 * @param operation \͑ΏHichart\
	 * @param orderList Vtgm[hi[Ă郊Xg
	 * @return int 0: Vtg\, 1: Vtgs(rs\Aqm[hȂ), 9: ̑G[
	 */
	public int checkYoungerBrotherShift(HichartNode operation, Vector orderList) {
		if (operation.getYoungerBrother() == null || OrderList.search(orderList, operation.getYoungerBrother()) == true) {
			return 1;
		} else {
			int precedence = PrecedenceRelation.getPrecedence(PrecedenceRelation.toNumber(operation), PrecedenceRelation.toNumber(operation.getYoungerBrother()));
			if (precedence == 0) {
				return 9;
			} else if (precedence == 1 || precedence == 2) {
				return 0;
			} else if (precedence == 4) {
				return 1;
			} else {
				return 9;
			}
		}
	}

	/**
	 * ʍ\
	 * @param operation \͑ΏHichart\
	 * @param orderList Vtgm[hi[Ă郊Xg
	 * @return boolean
	 */
	public boolean precedenceAnalysis(HichartNode operation, Vector orderList) {
		HichartNode handle, work, test;
		int production = -1;
		int precedence = -1;

		handle = Top.getTop(operation, orderList); //Top߂

		if (handle == null) {
			System.out.println("nh܂B\͎s");
			return false;
		} else {
			operation = operation.searchHichartNode(handle.getNodeID());
		}

		if (checkChild1Shift(operation, orderList) == 0) {
			precedence = PrecedenceRelation.getPrecedence(PrecedenceRelation.toNumber(operation), PrecedenceRelation.toNumber(operation.getChild1()));
			if (precedence == 1 || precedence == 2)
				Move.shift(operation.getChild1(), orderList);
		} else if (checkChild1Shift(operation, orderList) == 9) {
			return false;

		} else if (checkYoungerBrotherShift(operation, orderList) == 0) {
			precedence = PrecedenceRelation.getPrecedence(PrecedenceRelation.toNumber(operation), PrecedenceRelation.toNumber(operation.getYoungerBrother()));
			if (precedence == 1 || precedence == 2)
				Move.shift(operation.getYoungerBrother(), orderList);
		} else if (checkYoungerBrotherShift(operation, orderList) == 9) {
			return false;
		} else {
			//System.out.println("KT");
			production = prs.findProduction(handle);
			//System.out.println("ҌO production " + production);

			if (production != -1) { //&& (HichartNode.match(operation, handle)) == true) {
				//System.out.println(production + " ŊҌ");
				operation = ReplaceGraph.replaceGraph(operation, handle, production, orderList);
				if (operation == null) {
					return false;
				}
				//System.out.println("m[hu");
				//HichartNode.print_H_Node(operation);
				//System.out.println("sequence");
				//Sequence.getRoot().printSequence();
			} else
				return false;
		}
		State.currentNode = operation;
		return true;
	}
	
	/**
	 * \͐
	 * @return bollean tO
	 */
	public boolean exe_parse() {
		Sequence sequence_start = new Sequence(); //\͗pɓodlp̐擪
		HichartNode hichartList = new HichartNode(); //̓Oti[
		HichartNode operation = new HichartNode(); //\͂̂߂̍ƗpHichart̃Xg
		operation.hichartListFormat();
		Sequence sequence_temp = new Sequence(); //HichartXg_~[
		Coordinate coordinate = new Coordinate(); //Wp
		hichartList.hichartListFormat();
		TreeNode.setRoot();
		boolean parseFlag = false;
		boolean convertFlag = false;

		Info.start1 = System.currentTimeMillis();
		//System.out.println("͐`XgHichartXgɕϊ");
		convertFlag = TempNode.getRoot().ttoh(hichartList.getRoot().getChild1(), TempNode.getRoot().getNext());

		if (convertFlag == false) {
			Message.showMessage("Error at constructing Hihcart list.");
			return false;
		}
		Info.stop1 = System.currentTimeMillis();

		sequence_start.setNext(new Sequence());
		this.init();
		operation = operation.getRoot();

		Info.start2 = System.currentTimeMillis();
		this.generate_operation_hichart_list(hichartList.getRoot(), operation.getRoot()); //\͏pHichartXgRs[ō쐬
		Info.stop2 = System.currentTimeMillis();

		operation = operation.getRoot();
		//HichartNode.print_H_Node(operation);

		//fx[VV[PX̏
		Sequence.initialize();
		//HichartNode.print_H_Node(operation);

		//ʍ\͂s
		Info.start3 = System.currentTimeMillis();
		parseFlag = this.hcpggAnalysis(operation.getRoot());
		Info.stop3 = System.currentTimeMillis();

		if (parseFlag == true) {
			if (sequence_temp != null) { //fx[VV[PXꂽꍇ
				//\؂̍쐬
				ParseTree.generateParseTree(hichartList.getRoot());
				//System.out.println("\͊");
			}
		} else {
			//System.out.println("\͎s");
			return false;
		}
		return true;
	}
}