/*
 * 쐬: 2005/06/30
 * XV:
 * 
 */
package hicharted.parser;

import hicharted.dataStructure.*;
import hicharted.hcpgg.*;
import hicharted.*;
import java.util.*;

/**
 * parseɎgpOt̃NX
 */
public class ReplaceGraph {
	/**
	 * p[^œnꂽOtAnhAKɂOt̏s
	 * @param graph Ώۂ̃Otij
	 * @param handle ʃnh
	 * @param production ҌsK
	 * @return ӂ̃m[h
	 */
	public static HichartNode replaceGraph(HichartNode graph, HichartNode handle, int production, Vector orderList) {
		HichartNode lhs = null;
		HichartNode tmp = null;
		Productions prs = new Productions();
		HichartNode after = null;
		Vector before;

		//Ot̃[gi[
		graph = graph.getRoot();

		lhs = prs.getLhs(production);
		if (lhs == null)
			return null;

		tmp = graph.searchHichartNode(graph, handle.getNodeID());

		if (tmp == null)
			return null;

		//nhӂɏ
		if (tmp.getParent() != null) {
			if (tmp.getParent().getChild1().getNodeID() == tmp.getNodeID()) {
				tmp.getParent().setChild1(lhs);
			} else if (tmp.getParent().getChild2().getNodeID() == tmp.getNodeID()) {
				tmp.getParent().setChild2(lhs);
			}
			lhs.setParent(tmp.getParent());
		} else {
			if (tmp.getOlderBrother() != null) {
				tmp.getOlderBrother().setYoungerBrother(lhs);
			}
		}
		lhs.setNodeID(State.getNextNodeNum());

		//[gN̏
		if (lhs.getParent() != null) {
			lhs.setRoot(lhs.getParent().getRoot());
		} else if (lhs.getOlderBrother() != null) {
			lhs.setRoot(lhs.getOlderBrother().getRoot());
		}

		//N̏
		if (handle.getChild1() == null) {
			if (tmp.getChild1() != null) {
				tmp.getChild1().setParent(lhs);
				lhs.setChild1(tmp.getChild1());
			}
		}

		if (handle.getChild2() == null) {
			if (tmp.getChild2() != null) {
				tmp.getChild2().setParent(lhs);
				lhs.setChild2(tmp.getChild2());
			}
		}

		if (handle.getYoungerBrother() == null) {
			if (tmp.getYoungerBrother() != null) {
				tmp.getYoungerBrother().setOlderBrother(lhs);
				lhs.setYoungerBrother(tmp.getYoungerBrother());
			}
		}

		if (tmp.getOlderBrother() != null) {
			tmp.getOlderBrother().setYoungerBrother(lhs);
			lhs.setOlderBrother(tmp.getOlderBrother());
		}

		before = setBefore(handle);
		after = lhs.copyNode();

		//fx[VV[PX̐ݒ
		Sequence.getRoot().add(before, production, lhs);

		//Xg̏
		orderList = OrderList.remove(orderList, handle);
		orderList.add(lhs);

		//return graph;
		return lhs;

	}

	private static Vector setBefore(HichartNode handle) {
		Vector before = new Vector();
		HichartNode temp = new HichartNode();

		temp = handle.copyNode();
		before.add(temp);
		if (handle.getChild1() != null) {
			temp = new HichartNode();
			temp = handle.getChild1().copyNode();
			before.add(temp);
		}

		if (handle.getChild2() != null) {
			temp = new HichartNode();
			temp = handle.getChild2().copyNode();
			before.add(temp);
		}

		if (handle.getYoungerBrother() != null) {
			temp = new HichartNode();
			temp = handle.getYoungerBrother().copyNode();
			before.add(temp);
		}

		return before;
	}
}
